Bug 124061 - [patch]: lang/mlton (new features)
Summary: [patch]: lang/mlton (new features)
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Stefan Walter
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-05-28 11:10 UTC by Timothy Bourke
Modified: 2008-12-10 08:50 UTC (History)
1 user (show)

See Also:


Attachments
mlton.diff.gz.b64 (73.21 KB, application/octet-stream)
2008-05-28 11:10 UTC, Timothy Bourke
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Timothy Bourke 2008-05-28 11:10:02 UTC
This patch adds three features to the lang/mlton port: 
 * Support for FreeBSD 6.x
 * Support for compilation with SML/NJ
 * Cross-compilation with mingw32

It has been discussed with the port maintainer
(jesper.louis.andersen@gmail.com) who is also cc'ed.

To extract the patch:
    b64decode mlton.diff.gz.b64 | gunzip - mlton.diff
(ignore: unexpected end of file; mlton.diff has 16809 lines.)

The required bootstrap tarball is temporarily available at:
  http://www.cse.unsw.edu.au/~tbourke/software/mlton-20070826-1-0.i386-freebsd-6.tbz
It should probably be uploaded onto the MLton site.

SML/NJ compilation can take up to 20 hours.

The patches rely on a new port, devel/mingw32-libgmp4, currently awaiting
commit as ports/123391.
Comment 1 Edwin Groothuis freebsd_committer 2008-05-28 11:10:13 UTC
Maintainer of lang/mlton,

Please note that PR ports/124061 has just been submitted.

If it contains a patch for an upgrade, an enhancement or a bug fix
you agree on, reply to this email stating that you approve the patch
and a committer will take care of it.

The full text of the PR can be found at:
    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/124061

-- 
Edwin Groothuis via the GNATS Auto Assign Tool
edwin@FreeBSD.org
Comment 2 Edwin Groothuis freebsd_committer 2008-05-28 11:10:15 UTC
State Changed
From-To: open->feedback

Awaiting maintainers feedback (via the GNATS Auto Assign Tool)
Comment 3 Jesper Louis Andersen 2008-05-28 21:53:33 UTC
We've been discussing this patch and I approve of it ;)

On Wed, May 28, 2008 at 7:10 PM, Edwin Groothuis <edwin@freebsd.org> wrote:

> Maintainer of lang/mlton,
>
> Please note that PR ports/124061 has just been submitted.
>
> If it contains a patch for an upgrade, an enhancement or a bug fix
> you agree on, reply to this email stating that you approve the patch
> and a committer will take care of it.
>
> The full text of the PR can be found at:
>    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/124061
>
> --
> Edwin Groothuis via the GNATS Auto Assign Tool
> edwin@FreeBSD.org
>
Comment 4 Martin Wilke freebsd_committer 2008-06-01 21:28:06 UTC
State Changed
From-To: feedback->open

Maintainer has approved.
Comment 5 Timothy Bourke 2008-06-11 11:47:00 UTC
After applying the previous patch, please remove the
files/patch-runtime-cenv.h file.

The port maintainer noticed that the path is too rigid, and that it
would be better to edit runtime/Makefile adding
    CFLAGS+=        -I${LOCALBASE}/include

But, I found that compilation succeeds anyway without the patch file.

BTW, to test cross compilation, create a file test.sml:
    val _ = TextIO.print("Hello Windows\n");

And run:
    mlton -target mingw32 -cc mingw32-gcc test.sml
(ignore the warnings: mingw32-gcc: unrecognized option '-b')

Then:
    file test
should give:
    test: MS-DOS executable PE  for MS Windows (console) Intel 80386 32-bit
which will run in wine:
    wine ./test

Please let me know if any extra information could encourage committal!
Thank you.
Comment 6 Stefan Walter freebsd_committer 2008-10-18 09:57:53 UTC
Hi,

unfortunately, 'make fetch' already fails with me (on a 7.0 system):

###
=> mlton-20070826-1-0.i386-freebsd.tbz is not in /home/stefan/src/ports/lang/mlton/distinfo.
=> Either /home/stefan/src/ports/lang/mlton/distinfo is out of date, or
=> mlton-20070826-1-0.i386-freebsd.tbz is spelled incorrectly.
*** Error code 1

Stop in /home/stefan/src/ports/lang/mlton.
###

I have downloaded the bootstrap tarball manually, but as long as it can't
be fetched by the port automatically, the patch shouldn't be committed.
Please either make it available on a master site that's already in the
Makefile or add a master site where the file can be downloaded.

Regards,
Stefan
Comment 7 Stefan Walter freebsd_committer 2008-10-20 10:41:53 UTC
Responsible Changed
From-To: freebsd-ports-bugs->stefan

Track this.
Comment 8 Stefan Walter freebsd_committer 2008-10-22 14:08:17 UTC
Submitter replied in private mail:

Timothy Bourke, 22.10.08, 14:15h CEST:

> Hello Stefan,
> 
> Thank you for looking at the submission.
> 
> Sorry for the delay in response. I'm out of town at the moment, but I
> will fix this problem next week when I return.
> 
> Best regards,
> 
> Tim.
Comment 9 Timothy Bourke 2008-11-01 23:56:16 UTC
Hi Stefan,

Sorry for the delay.

On Oct 18 at 10:57 +0200, Stefan Walter wrote:
> unfortunately, 'make fetch' already fails with me (on a 7.0 system):


There may have been some changes in the months since the patch was
submitted.

> 
> ###
> => mlton-20070826-1-0.i386-freebsd.tbz is not in /home/stefan/src/ports/lang/mlton/distinfo.
> => Either /home/stefan/src/ports/lang/mlton/distinfo is out of date, or
> => mlton-20070826-1-0.i386-freebsd.tbz is spelled incorrectly.
> *** Error code 1
> 
> Stop in /home/stefan/src/ports/lang/mlton.
> ###


It seems that the filename should be:
    mlton-20070826-1.i386-freebsd.tbz (i.e. no `-0')

> I have downloaded the bootstrap tarball manually, but as long as it can't
> be fetched by the port automatically, the patch shouldn't be committed.
> Please either make it available on a master site that's already in the
> Makefile or add a master site where the file can be downloaded.


The attached diff fixes the problem and adds a url to my website where
I have uploaded the boot files (since the one for freebsd-6 is not on
the official site).

Unfortunately I no longer have access to a machine running FreeBSD 7
to test the port.

Thank you,

Tim.
Comment 10 dfilter service freebsd_committer 2008-12-10 08:44:33 UTC
stefan      2008-12-10 08:44:24 UTC

  FreeBSD ports repository

  Modified files:
    lang/mlton           Makefile distinfo pkg-plist 
  Added files:
    lang/mlton/files     add-local-cross ml.grm.sig ml.grm.sml 
                         ml.lex.sml mlb.grm.sig mlb.grm.sml 
                         mlb.lex.sml patch-Makefile 
                         patch-bin-mlton_script 
                         patch-runtime-Makefile 
                         patch-runtime-cenv.h 
                         patch-runtime-mingw.c 
                         patch-runtime-mingw.h upgrade-basis.sml 
                         yacc.grm.sig yacc.grm.sml yacc.lex.sml 
  Log:
  This patch adds three features to the lang/mlton port:
  * Support for FreeBSD 6.x
  * Support for compilation with SML/NJ
  * Cross-compilation with mingw32
  
  PR:             124061
  Submitted by:   Timothy Bourke <timbob@bigpond.com>
  Approved by:    maintainer
  
  Revision  Changes    Path
  1.18      +56 -10    ports/lang/mlton/Makefile
  1.7       +6 -3      ports/lang/mlton/distinfo
  1.1       +197 -0    ports/lang/mlton/files/add-local-cross (new)
  1.1       +88 -0     ports/lang/mlton/files/ml.grm.sig (new)
  1.1       +5497 -0   ports/lang/mlton/files/ml.grm.sml (new)
  1.1       +5660 -0   ports/lang/mlton/files/ml.lex.sml (new)
  1.1       +32 -0     ports/lang/mlton/files/mlb.grm.sig (new)
  1.1       +894 -0    ports/lang/mlton/files/mlb.grm.sml (new)
  1.1       +1854 -0   ports/lang/mlton/files/mlb.lex.sml (new)
  1.1       +22 -0     ports/lang/mlton/files/patch-Makefile (new)
  1.1       +18 -0     ports/lang/mlton/files/patch-bin-mlton_script (new)
  1.1       +84 -0     ports/lang/mlton/files/patch-runtime-Makefile (new)
  1.1       +11 -0     ports/lang/mlton/files/patch-runtime-cenv.h (new)
  1.1       +43 -0     ports/lang/mlton/files/patch-runtime-mingw.c (new)
  1.1       +20 -0     ports/lang/mlton/files/patch-runtime-mingw.h (new)
  1.1       +68 -0     ports/lang/mlton/files/upgrade-basis.sml (new)
  1.1       +54 -0     ports/lang/mlton/files/yacc.grm.sig (new)
  1.1       +1053 -0   ports/lang/mlton/files/yacc.grm.sml (new)
  1.1       +901 -0    ports/lang/mlton/files/yacc.lex.sml (new)
  1.6       +10 -0     ports/lang/mlton/pkg-plist
_______________________________________________
cvs-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/cvs-all
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"
Comment 11 Stefan Walter freebsd_committer 2008-12-10 08:49:06 UTC
State Changed
From-To: open->closed

Committed, thanks!